#!/bin/bash

# [CJ]

SRC=$1
DST=$2

if [ -z "${ONE_LOCATION}" ]; then
    TMCOMMON=/usr/lib/one/mads/tm_common.sh
else
    TMCOMMON=$ONE_LOCATION/lib/mads/tm_common.sh
fi

. $TMCOMMON

log "tm_mv.sh $*"

SRC_PATH=`arg_path $SRC`
SRC_HOST=`arg_host $SRC`
DST_PATH=`arg_path $DST`
DST_HOST=`arg_host $DST`

if [ $SRC_PATH = $DST_PATH ]
then
	exit 0
fi

SEDCMD="s~$ONE_LOCATION~$VM_DIR~"
DST_PATH=`echo $DST_PATH | sed $SEDCMD`
SRC_PATH=`echo $SRC_PATH | sed $SEDCMD`

if [ $DST_HOST = `hostname` ]
then
	ssh $SRC_HOST test -d $SRC_PATH
	if [ $? -eq 0 ]
	then
		log "ssh $SRC_HOST \"mkdir -p $DST_PATH && mv $SRC_PATH $DST_PATH && rmdir `dirname $SRC_PATH`\""
		ssh $SRC_HOST "mkdir -p $DST_PATH && mv $SRC_PATH $DST_PATH && rmdir `dirname $SRC_PATH`"
	else
		ssh $SRC_HOST qemu-img info $SRC_PATH | grep -q "^backing file:"
		if [ $? -eq 0 ]
		then
			log "ssh $SRC_HOST \"mkdir -p `dirname $DST_PATH` && qemu-img convert $SRC_PATH -O qcow2 $DST_PATH && rm $SRC_PATH\""
			ssh $SRC_HOST "mkdir -p `dirname $DST_PATH` && qemu-img convert $SRC_PATH -O qcow2 $DST_PATH && rm $SRC_PATH"
		else
			log "ssh $SRC_HOST \"mkdir -p `dirname $DST_PATH` && mv $SRC_PATH $DST_PATH\""
			ssh $SRC_HOST "mkdir -p `dirname $DST_PATH` && mv $SRC_PATH $DST_PATH"
		fi
	fi
else
	ssh $DST_HOST test -d $SRC_PATH
	if [ $? -eq 0 ]
	then
		log "ssh $DST_HOST \"mkdir -p `dirname $DST_PATH` && mv $SRC_PATH $DST_PATH && rmdir `dirname $SRC_PATH`\""
		ssh $DST_HOST "mkdir -p `dirname $DST_PATH` && mv $SRC_PATH $DST_PATH && rmdir `dirname $SRC_PATH`"
	else
		log "ssh $DST_HOST \"mv $SRC_PATH $DST_PATH\""
		ssh $DST_HOST "mv $SRC_PATH $DST_PATH"
	fi
fi
